unit HarvestDataProcessor;
{$R *.dcr}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBTables, DB;

type
  THarvestDataProcessor = class(TComponent)
  private
    FFileName: string;
    FTable: TTable;
    DataText: TStringList;
    ProcMemo: TStringList;
    procedure EntStr(var name:string; value:string);
    procedure EntInt(var name:string; value:integer);
    procedure GetStr(var name:string);
    procedure GetInt(var name:string);
    procedure SaveDataToFile;
    procedure ProcessDataFromRecord(var t1:string);
    procedure ProcessDataFromDatabase;
    procedure ProcessDataFromProcMemo;
    procedure ProcessDataFromMemos;
    procedure LoadDataFromFile;
  protected
    { Protected declarations }
  public
   procedure ProcessTextFile;
   procedure ProcessDataBase;
  published
   FirstText: TStringList;
   SecondText: TStringList;
   constructor Create(AOwner:TComponent);override;
   destructor Destroy;override;
   property HarvestDatFileName: string
            read FFileName
            write FFileName;

   property DataTableName: TTable
            read Ftable
            write Ftable
            stored false;
  end;

procedure Register;
var
  ID : Integer;
  value,HexType:string;
  TerType:byte;
implementation

procedure Register;
begin
  RegisterComponents('Game Controls', [THarvestDataProcessor]);
end;

constructor THarvestDataProcessor.Create(AOwner:TComponent);
begin
 inherited create(AOwner);
// FTable := TTable.Create(AOwner);
 FirstText := TStringList.Create;
   FirstText.Clear;
 DataText := TStringList.Create;
   DataText.Clear;
 SecondText := TStringList.Create;
   SecondText.Clear;
 ProcMemo := TStringList.Create;
   ProcMemo.Clear;
end;

destructor THarvestDataProcessor.Destroy;
begin
// FTable.close;
 //FTable.Destroy; //cause problems prbably becouse it wants to destroy "orginal" table ?
 FirstText.Destroy;
 DataText.Destroy;
 SecondText.Destroy;
 ProcMemo.Destroy;
 inherited Destroy;
end;

procedure THarvestDataProcessor.EntStr(var name:string; value:string);
begin
FTable.FieldByName(name).asString:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure THarvestDataProcessor.EntInt(var name:string; value:integer);
begin
FTable.FieldByName(name).asInteger:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure THarvestDataProcessor.GetStr(var name:string);
begin
value:=FTable.FieldByName(name).asString;
//LDB.PB1.StepIt;
end;

procedure THarvestDataProcessor.GetInt(var name:string);
var
V:integer;
begin
V:=FTable.FieldByName(name).asInteger;
value:=inttostr(V);
//LDB.PB1.StepIt;
end;

procedure THarvestDataProcessor.SaveDataToFile;
var
i:integer;
StrBuildDataFile:TextFile;
begin
FFileName:= HarvestDatFileName;
assignfile(StrBuildDataFile,FFileName);
rewrite(StrBuildDataFile);
for i:=0 to FirstText.count-1 do
 begin
 writeln(StrBuildDataFile,FirstText.strings[i]);
 end;

for i:=0 to DataText.count-1 do
 begin
 writeln(StrBuildDataFile,DataText.strings[i]);
 end;

for i:=0 to SecondText.count-1 do
 begin
 writeln(StrBuildDataFile,SecondText.strings[i]);
 end;
closefile(StrBuildDataFile);
end;

procedure THarvestDataProcessor.ProcessDataFromRecord(var t1:string);
var
name:string;
i,x:integer;
NoForvard:byte;
begin

   {LDB.Label2.Caption:=value;
   LDB.Label2.Refresh;}
   name:=FTable.FieldDefs.Items[2].Name;
   GetStr(name);
   t1:='   "'+value+'"';

   for i:=length(t1) to 16 do t1:=t1+' ';
   NoForvard:=0;
   for i:=3 to 8 do
    begin
    if ((i mod 2)<>0) then
     begin
     name:=FTable.FieldDefs.Items[i].Name;
     GetStr(name);
     if (value<>'') and (value<>' ') then
      begin
       for x:=length(t1) to length(t1)+6-length(value) do t1:=t1+' ';
       t1:=t1+'"'+value+'"';
       NoForvard:=0;
      end
      else NoForvard:=1;
     end
    else
     if NoForvard=0 then
     begin
      begin
       name:=FTable.FieldDefs.Items[i].Name;
       GetInt(name);
       if (value<>'') and (value<>' ')then
        begin
         for x:=length(t1) to length(t1)+3-length(value) do t1:=t1+' ';
         t1:=t1+'"'+value+'"';
        end;
      end;
     end;
    end;
   t1:=t1+' "@"';
end;

procedure THarvestDataProcessor.ProcessDataFromDatabase;
var
t1:string;
name:string;
begin
DataText.Clear;
FTable.open;
FTable.Refresh;
FTable.First;
FTable.edit;
{LDB.Caption:='Saving Data ...';
LDB.PB1.Position:=0;
LDB.PB2.Position:=0;
LDB.show;
LDB.Label1.Caption:='Group: '+Inttostr(AGr);
LDB.Label2.Caption:='';}
while not (FTable.Eof) do
 begin
 if TerType=0 then
  begin
   name:='HexName';
   GetStr(name);
   DataText.Add('{ "'+value+'"');
  end;
  inc(TerType);
  ProcessDataFromRecord(t1);
  { LDB.Label1.Caption:='Group: '+Inttostr(AGnr);
   LDB.Label1.Refresh;
   LDB.PB2.StepIt;}
  DataText.Add(t1);
  FTable.Next;
  if TerType=5 then
  begin
   DataText.Add('}');
   TerType:=0;
  end;
 end;
FTable.close;
//LDB.hide;
end;

procedure THarvestDataProcessor.LoadDataFromFile;
var
FStrFile: TextFile;
TempL:string;
FileTextType:byte;//1-firs;2-data;3-second
LineCount:byte;
begin//main
 FileTextType:=1;
 FFileName:=HarvestDatFileName;
 if (FFileName<>'') and Fileexists(FFileName) then
  begin//Filename corect
   FirstText.Clear;
   DataText.Clear;
   SecondText.Clear;
   assignfile(FStrFile,FFileName);
   reset(FStrFile);
   LineCount:=0;
   while not EoF(FStrFile) do
    begin//while
     readln(FStrFile,TempL);
     case FileTextType of
     1:
      begin
       if (TempL<>'') and (TempL[1]='/') then FirstText.Add(TempL)
       else if (TempL<>'') and (TempL[1]='{') then
        begin
         DataText.Add(TempL);
         FileTextType:=2;
        end;
      end;

     2:
      begin
      if (TempL<>'') and (TempL[1]<>'/') then DataText.Add(tempL)
      else if (TempL<>'') and (TempL[1]='}') then
       begin
       inc(LineCount);
       if LineCount=11 then FileTextType:=3;
       end;
      end;
     3:
      begin
       SecondText.Add(TempL);
      end;
    end;//case of
  end;//while
   closefile(FStrFile);
 end//Filename corect
 else MessageDlg('File not found!',mtWarning,[mbOK],0);
end;//main

procedure THarvestDataProcessor.ProcessDataFromProcMemo;
var
PM:TStringList;
i,value:integer;
FName,temp:string;
begin//main
 PM:=ProcMemo;
 FTable.edit;

   FName:='ID';
   EntInt(FName,ID);

   FName:='HexName';
   temp:=HexType;
   EntStr(FName,temp);

   if PM.Count>1 then
    begin
     FName:='PlanetName';
     temp:=PM.Strings[0];
     EntStr(FName,temp);
    end;

   for i:=2 to PM.Count do
    begin
    if ((i mod 2)=0) then
     begin
     FName:=FTable.FieldDefs.Items[i+1].Name;
     temp:=PM.Strings[i-1];
     EntStr(FName,temp);
     end
    else
     begin
     FName:=FTable.FieldDefs.Items[i+1].Name;
     value:=strtoint(PM.Strings[i-1]);
     EntInt(FName,value);
     end;
    end;

 Ftable.Post;
 Inc(ID);
//MessageDlg('complited',mtWarning,[mbOK],0);
end;//main

procedure THarvestDataProcessor.ProcessDataFromMemos;
var
TM:TStringList;
TempL,ProcL:string;
i,x,y:integer;
begin//main
TM:=DataText;
   Ftable.Close;
   Ftable.Exclusive:=true;
   Ftable.open;
   Ftable.edit;
   Ftable.EmptyTable;
   Ftable.First;
   FTable.Insert;
//MessageDlg('Ex = on',mtWarning,[mbOK],0);
   HexType:='';
   ID:=0;
for i:=0 to TM.Count-1 do
 begin//TM loop
  TempL:=TM.Strings[i];
  ProcMemo.Clear;
  if (TempL<>'') then
   begin//Line loop
    ProcL:='';
    if TempL[1]='{' then HexType:='';
    for x:=1 to length(TempL) do
     begin
      if (TempL[1]<>'{') then
       begin
        //LineType:=2;
        if (TempL[x]<>' ') and (TempL[x]<>'"') and (TempL[x]<>'@') then ProcL:=ProcL+TempL[x]
        else
         begin
          if (ProcL<>'') then ProcMemo.Add(ProcL);
          ProcL:='';
         end;
       end
      else if (TempL[1]='{') then
       begin
        //LineType:=1;
        if (TempL[x]<>'"') and (TempL[x]<>'{') then HexType:=HexType+TempL[x];
       end;
     end;
   end;//Line loop
   TempL:='';
   y:=0;
   for x:=1 to length(HexType) do
    begin
    case y of
    0:
     begin
     If HexType[x]<>' ' then
      begin
       y:=1;
       TempL:=TempL+HexType[x];
      end;
     end;
    1:
     begin
      TempL:=TempL+HexType[x];
     end;
    end;
    end;
    HexType:=TempL;
   if ProcMemo.Count>0 then ProcessDataFromProcMemo;
  FTable.Next;
  FTable.Append;
 end;//TM loop
   Ftable.Close;
   Ftable.Exclusive:=false;
//MessageDlg('Ex = off',mtWarning,[mbOK],0);
end;//Main

procedure THarvestDataProcessor.ProcessTextFile;
begin
if (FFileName<>'') and (fileexists(FFileName)=true) then
 begin
 LoadDataFromFile;
 ProcessDataFromMemos;
 FTable.close;
 MessageDlg('Transfering data to database complited.',mtInformation,[mbok],0);
 end
else MessageDlg('Wrong data file name!',mtWarning,[mbOK],0);
end;

procedure THarvestDataProcessor.ProcessDataBase;
begin
if (HarvestDatFileName<>'') then
 begin
  ProcessDataFromDatabase;
  SaveDataToFile;
  Ftable.close;
  MessageDlg('Transfering data to external data file complited.',mtInformation,[mbok],0);
 end
else  MessageDlg('Wrong data file name',mtWarning,[mbok],0);
end;


end.
