unit ProdDatProcessor;
{$R *.dcr}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBTables, DB;

type
  TProdDatProcessor = class(TComponent)
  private
    FFileName: string;
    FTable: TTable;
    DataText: TStringList;
    ProcMemo: TStringList;
    procedure EntStr(var name:string; value:string);
    procedure EntInt(var name:string; value:integer);
    procedure GetStr(var name:string);
    procedure GetInt(var name:string);
    procedure SaveDataToFile;
    procedure ProcessDataFromRecord(var t1:string);
    procedure ProcessDataFromDatabase;
    procedure ProcessDataFromProcMemo;
    procedure ProcessDataFromMemos;
    procedure LoadDataFromFile;
  protected
    { Protected declarations }
  public
   procedure ProcessTextFile;
   procedure ProcessDataBase;
  published
   FirstText: TStringList;
   SecondText: TStringList;
   constructor Create(AOwner:TComponent);override;
   destructor Destroy;override;
   property ProdDatFileName: string
            read FFileName
            write FFileName;

   property DataTableName: TTable
            read Ftable
            write Ftable
            stored false;
  end;

procedure Register;
var
  value:string;
  ID: integer;
implementation

procedure Register;
begin
  RegisterComponents('Game Controls', [TProdDatProcessor]);
end;

constructor TProdDatProcessor.Create(AOwner:TComponent);
begin
 inherited create(AOwner);
// FTable := TTable.Create(AOwner);
 FirstText := TStringList.Create;
   FirstText.Clear;
 DataText := TStringList.Create;
   DataText.Clear;
 SecondText := TStringList.Create;
   SecondText.Clear;
 ProcMemo := TStringList.Create;
   ProcMemo.Clear;
end;

destructor TProdDatProcessor.Destroy;
begin
// FTable.close;
 //FTable.Destroy; //cause problems prbably becouse it wants to destroy "orginal" table ?
 FirstText.Destroy;
 DataText.Destroy;
 SecondText.Destroy;
 ProcMemo.Destroy;
 inherited Destroy;
end;

procedure TProdDatProcessor.EntStr(var name:string; value:string);
begin
FTable.FieldByName(name).asString:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure TProdDatProcessor.EntInt(var name:string; value:integer);
begin
FTable.FieldByName(name).asInteger:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure TProdDatProcessor.GetStr(var name:string);
begin
value:=FTable.FieldByName(name).asString;
//LDB.PB1.StepIt;
end;

procedure TProdDatProcessor.GetInt(var name:string);
var
V:integer;
begin
V:=FTable.FieldByName(name).asInteger;
value:=inttostr(V);
//LDB.PB1.StepIt;
end;

procedure TProdDatProcessor.SaveDataToFile;
var
i:integer;
ProdDatDataFile:TextFile;
begin
FFileName:= ProdDatFileName;
assignfile(ProdDatDataFile,FFileName);
rewrite(ProdDatDataFile);
for i:=0 to FirstText.count-1 do
 begin
 writeln(ProdDatDataFile,FirstText.strings[i]);
 end;

for i:=0 to DataText.count-1 do
 begin
 writeln(ProdDatDataFile,DataText.strings[i]);
 end;

for i:=0 to SecondText.count-1 do
 begin
 writeln(ProdDatDataFile,SecondText.strings[i]);
 end;
closefile(ProdDatDataFile);
end;

procedure TProdDatProcessor.ProcessDataFromRecord(var t1:string);
var
name:string;
i,x:integer;
begin
   t1:='';

   name:='City';
   GetStr(name);
   {LDB.Label2.Caption:=value;
   LDB.Label2.Refresh;}
   t1:='"city" "'+value+'"';

   DataText.Add(t1);
   for x:=1 to 3 do
   begin
    name:='Need'+inttostr(x);
    GetStr(name);
    if value<>'' then
     begin
      t1:='"need" "'+value+'"';
      for i:=length(t1) to 24 do t1:=t1+' ';
      name:='Value'+inttostr(x);
      GetInt(name);
      if length(value)=1 then t1:=t1+'"0'+value+'"'
      else t1:=t1+'"'+value+'"';
      DataText.Add(t1);
      t1:='';
     end;
    end;

   name:='Make';
   GetStr(name);
   t1:='"make" "'+value+'"';
   name:='MValue';
   GetInt(name);
   for i:=length(t1) to 24 do t1:=t1+' ';
   t1:=t1+'"'+value+'"';
   DataText.Add(t1);
end;

procedure TProdDatProcessor.ProcessDataFromDatabase;
var
t1:string;
begin
DataText.Clear;
FTable.open;
FTable.Refresh;
FTable.First;
FTable.edit;
{LDB.Caption:='Saving Data ...';
LDB.PB1.Position:=0;
LDB.PB2.Position:=0;
LDB.show;
LDB.Label1.Caption:='Group: '+Inttostr(AGr);
LDB.Label2.Caption:='';}
while not (FTable.Eof) do
 begin
  DataText.Add('{');
  ProcessDataFromRecord(t1);
  { LDB.Label1.Caption:='Group: '+Inttostr(AGnr);
   LDB.Label1.Refresh;
   LDB.PB2.StepIt;}
  DataText.Add('}');
  FTable.Next;
 end;

FTable.close;
//LDB.hide;
end;

procedure TProdDatProcessor.LoadDataFromFile;
var
FStrFile: TextFile;
TempL:string;
FileTextType,x:byte;//1-firs;2-data;3-second
begin//main
 FileTextType:=1;
 FFileName:=ProdDatFileName;
 if (FFileName<>'') and Fileexists(FFileName) then
  begin//Filename corect
   FirstText.Clear;
   DataText.Clear;
   SecondText.Clear;
   assignfile(FStrFile,FFileName);
   reset(FStrFile);
   x:=0;
   while not EoF(FStrFile) do
    begin//while
     readln(FStrFile,TempL);
     case FileTextType of
     1:
      begin
       if (TempL<>'') and (TempL[1]='/') then FirstText.Add(TempL)
       else if (TempL<>'') and (TempL[1]='{') then
        begin
         DataText.Add(TempL);
         FileTextType:=2;
        end;
      end;

     2:
      begin
      if (TempL<>'') and (TempL[1]<>'/') and (TempL[1]<>'}') then DataText.Add(tempL)
      else if (TempL<>'') and (TempL[1]='}') then
       begin
       DataText.Add(TempL);
       inc(x);
       if x=7 then FileTextType:=3;
       end;
      end;
     3:
      begin
       SecondText.Add(TempL);
      end;
    end;//case of
  end;//while
   closefile(FStrFile);
 end//Filename corect
 else MessageDlg('File not found!',mtWarning,[mbOK],0);
end;//main

procedure TProdDatProcessor.ProcessDataFromProcMemo;
var
PM:TStringList;
i,value,x:integer;
FName,temp:string;
begin//main
 PM:=ProcMemo;
 FTable.edit;
 FName:='ID';
 EntInt(Fname,ID);
//MessageDlg('Processing...'+inttostr(PM.count),mtWarning,[mbOK],0);
 FName:=PM.Strings[0];
 Temp:=PM.Strings[1];
 EntStr(Fname,temp);
 x:=0;
 i:=2;
  repeat
   if PM.Strings[i]='need' then
    begin
     inc(x);
 //   messagedlg('find - need nr:'+inttostr(x),mtinformation,[mbok],0);
     inc(i);
     FName:='Need'+inttostr(x);
     Temp:=PM.Strings[i];
     EntStr(FName,Temp);

     inc(i);
     FName:='Value'+inttostr(x);
     value:=strtoint(PM.Strings[i]);
     EntInt(FName,value);

     inc(i);
    end
   else if PM.Strings[i]='make' then
    begin
 //   messagedlg('find - make',mtinformation,[mbok],0);
     x:=4;

     inc(i);
     FName:='Make';
     Temp:=PM.Strings[i];
     EntStr(FName,Temp);

     inc(i);
     FName:='MValue';
     value:=strtoint(PM.Strings[i]);
     EntInt(FName,value);
    end;
  until x=4;

 Ftable.Post;
 Inc(ID);
//MessageDlg('complited',mtWarning,[mbOK],0);
end;//main

procedure TProdDatProcessor.ProcessDataFromMemos;
var
TM:TStringList;
TempL,ProcL:string;
i,x,ProdCount:integer;
begin//main
TM:=DataText;
   Ftable.Close;
   Ftable.Exclusive:=true;
   Ftable.open;
   Ftable.edit;
   Ftable.EmptyTable;
   Ftable.First;
   FTable.Insert;
//MessageDlg('Ex = on',mtWarning,[mbOK],0);
   //ProdCount:=0;
 ProdCount:=0;
 ID:=0;
for i:=0 to TM.Count-1 do
 begin//TM loop
  TempL:=TM.Strings[i];
  //ProcMemo.Clear;
  if (TempL<>'') and (TempL[1]='{') then
   begin
   ProdCount:=0;
   end;
  for x:=1 to length(TempL) do
   begin
    if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]<>'"') and (TempL[x]<>'}') and (TempL[x]<>'{') then ProcL:=ProcL+TempL[x]
    else if (TempL<>'') and (TempL[x]<>'{') and (TempL[x]<>'}') and ((TempL[x]=' ') or (TempL[x]='"')) and (ProcL<>'') then
     begin
      ProcMemo.Add(ProcL);
      ProcL:='';
     end
    else if (TempL<>'') and (TempL[x]='}') then ProdCount:=1;
   end;
if ProdCount=1 then
  begin
//   messagedlg('Processing...',mtinformation,[mbok],0);
   ProcessDataFromProcMemo;
   ProcMemo.Clear;
  end;
  FTable.Next;
  FTable.Append;
 end;//TM loop
   Ftable.Close;
   Ftable.Exclusive:=false;
   Ftable.Close;

//MessageDlg('Ex = off',mtWarning,[mbOK],0);
end;//Main

procedure TProdDatProcessor.ProcessTextFile;
begin
if (FFileName<>'') and (fileexists(FFileName)=true) then
 begin
 LoadDataFromFile;
 ProcessDataFromMemos;
 Ftable.Close;
 MessageDlg('Transfering data to database complited.',mtInformation,[mbok],0);
 end
else MessageDlg('Wrong data file name!',mtWarning,[mbOK],0);
end;

procedure TProdDatProcessor.ProcessDataBase;
begin
if (ProdDatFileName<>'') then
 begin
  ProcessDataFromDatabase;
  SaveDataToFile;
  Ftable.Close;
  MessageDlg('Transfering data to external data file complited.',mtInformation,[mbok],0);
 end
else  MessageDlg('Wrong data file name',mtWarning,[mbok],0);
end;


end.
