unit TechDatProcessor;
{$R *.dcr}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBTables, DB;

type
  TTechDatProcessor = class(TComponent)
  private
    FFileName: string;
    FTable: TTable;
    DataText: TStringList;
    ProcMemo: TStringList;
    procedure EntStr(var name:string; value:string);
    procedure EntInt(var name:string; value:integer);
    procedure GetStr(var name:string);
    procedure GetInt(var name:string);
    procedure SaveDataToFile;
    procedure ProcessDataFromRecord(var t1:string);
    procedure ProcessDataFromDatabase;
    procedure ProcessDataFromProcMemo;
    procedure ProcessDataFromMemos;
    procedure LoadDataFromFile;
  protected
    { Protected declarations }
  public
   procedure ProcessTextFile;
   procedure ProcessDataBase;
  published
   FirstText: TStringList;
   SecondText: TStringList;
   constructor Create(AOwner:TComponent);override;
   destructor Destroy;override;
   property TechDatFileName: string
            read FFileName
            write FFileName;

   property DataTableName: TTable
            read Ftable
            write Ftable
            stored false;

  end;

procedure Register;
var
  value:string;
  Extra: string;
  ID:Integer;
implementation

procedure Register;
begin
  RegisterComponents('Game Controls', [TTechDatProcessor]);
end;

constructor TTechDatProcessor.Create(AOwner:TComponent);
begin
 inherited create(AOwner);
// FTable := TTable.Create(AOwner);
 FirstText := TStringList.Create;
   FirstText.Clear;
 DataText := TStringList.Create;
   DataText.Clear;
 SecondText := TStringList.Create;
   SecondText.Clear;
 ProcMemo := TStringList.Create;
   ProcMemo.Clear;
end;

destructor TTechDatProcessor.Destroy;
begin
// FTable.close;
 FirstText.Destroy;
 DataText.Destroy;
 SecondText.Destroy;
 ProcMemo.Destroy;
// FTable.Destroy; //cause problems
 inherited Destroy;
end;

procedure TTechDatProcessor.EntStr(var name:string; value:string);
begin
FTable.FieldByName(name).asString:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure TTechDatProcessor.EntInt(var name:string; value:integer);
begin
FTable.FieldByName(name).asInteger:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure TTechDatProcessor.GetStr(var name:string);
begin
value:=FTable.FieldByName(name).asString;
//LDB.PB1.StepIt;
end;

procedure TTechDatProcessor.GetInt(var name:string);
var
V:integer;
begin
V:=FTable.FieldByName(name).asInteger;
value:=inttostr(V);
//LDB.PB1.StepIt;
end;

procedure TTechDatProcessor.SaveDataToFile;
var
i:integer;
TechDataFile:TextFile;
begin
FFileName:= TechDatFileName;
assignfile(TechDataFile,FFileName);
rewrite(TechDataFile);
for i:=0 to FirstText.count-1 do
 begin
 writeln(TechDataFile,FirstText.strings[i]);
 end;

for i:=0 to DataText.count-1 do
 begin
 writeln(TechDataFile,DataText.strings[i]);
 end;

for i:=0 to SecondText.count-1 do
 begin
 writeln(TechDataFile,SecondText.strings[i]);
 end;
closefile(TechDataFile);
end;

procedure TTechDatProcessor.ProcessDataFromRecord(var t1:string);
var
name:string;
i,x:integer;
begin
   t1:='';

   name:='Name';
   GetStr(name);
   {LDB.Label2.Caption:=value;
   LDB.Label2.Refresh;}
   t1:='   "name" "'+value+'"';

   for i:=length(t1) to 40 do t1:=t1+' ';
   t1:=t1+'"stats" "';

   for i:=2 to 8 do
    begin
     name:=FTable.FieldDefs.Items[i].Name;
     GetInt(name);
     for x:=length(t1) to length(t1)+5-length(value) do t1:=t1+' ';
     t1:=t1+value;
    end;
   t1:=t1+'"  "extra" "';
   name:='Extra';
   GetStr(name);
   t1:=t1+value+'"';

end;

procedure TTechDatProcessor.ProcessDataFromDatabase;
var
t1:string;
begin
DataText.Clear;
FTable.open;
FTable.Refresh;
FTable.First;
FTable.edit;
{LDB.Caption:='Saving Data ...';
LDB.PB1.Position:=0;
LDB.PB2.Position:=0;
LDB.show;
LDB.Label1.Caption:='Group: '+Inttostr(AGr);
LDB.Label2.Caption:='';}
DataText.Add('{');
while not (FTable.Eof) do
 begin
  ProcessDataFromRecord(t1);
  { LDB.Label1.Caption:='Group: '+Inttostr(AGnr);
   LDB.Label1.Refresh;
   LDB.PB2.StepIt;}
  DataText.Add(t1);
  FTable.Next;
 end;
DataText.Add('}');
FTable.close;
//LDB.hide;
end;

procedure TTechDatProcessor.LoadDataFromFile;
var
FStrFile: TextFile;
TempL:string;
FileTextType:byte;//1-firs;2-data;3-second
begin//main
 FileTextType:=1;
 FFileName:=TechDatFileName;
 if (FFileName<>'') and Fileexists(FFileName) then
  begin//Filename corect
   FirstText.Clear;
   DataText.Clear;
   SecondText.Clear;
   assignfile(FStrFile,FFileName);
   reset(FStrFile);
   while not EoF(FStrFile) do
    begin//while
     readln(FStrFile,TempL);
     case FileTextType of
     1:
      begin
       if (TempL<>'') and (TempL[1]='/') then FirstText.Add(TempL)
       else if (TempL<>'') and (TempL[1]='{') then
        begin
         //form1.DataText.Lines.Add(TempL);
         FileTextType:=2;
        end;
      end;

     2:
      begin
      if (TempL<>'') and (TempL[1]<>'/') and (TempL[1]<>'}') then DataText.Add(tempL)
      else if (TempL<>'') and (TempL[1]='}') then
       begin
       //form1.DataText.Lines.Add(TempL);
       FileTextType:=3;
       end;
      end;
     3:
      begin
       SecondText.Add(TempL);
      end;
    end;//case of
  end;//while
   closefile(FStrFile);
 end//Filename corect
 else MessageDlg('File not found!',mtWarning,[mbOK],0);
end;//main

procedure TTechDatProcessor.ProcessDataFromProcMemo;
var
PM:TStringList;
i,value,x:integer;
FName,temp:string;
begin//main
 PM:=ProcMemo;
 FTable.edit;
//MessageDlg('Processing...'+inttostr(PM.count),mtWarning,[mbOK],0);
 FName:='ID';
 EntInt(FName,ID);

 FName:='Name';
 Temp:='';
 x:=0;
  if PM.Count > 10 then
   begin
    x:=PM.Count-9;
    for i:=1 to x do
     begin
      temp:=temp+PM.strings[i]+' ';
     end;
    EntStr(FName,temp);
   end
  else EntStr(FName,PM.strings[1]);

 if x>0 then x:=x-1;
 for i:=2 to 8 do
  begin
   FName:=FTable.FieldDefs.Items[i].Name;
   value:=strtoint(PM.strings[i+1+x]);
   EntInt(FName,value);
  end;
  FName:='Extra';
//  messagedlg('Extra to sav: '+extra,mtinformation,[mbok],0);
  EntStr(FName,Extra);
 Ftable.Post;
//MessageDlg('complited',mtWarning,[mbOK],0);
 Inc(ID);
end;//main

procedure TTechDatProcessor.ProcessDataFromMemos;
var
TM:TStringList;
TempL,ProcL:string;
i,x,d:integer;
Extr:byte;
begin//1
TM:=DataText;
   Ftable.Close;
   Ftable.Exclusive:=true;
   Ftable.open;
   Ftable.edit;
   Ftable.EmptyTable;
   Ftable.First;
   FTable.Insert;
   ID:=0;
for i:=0 to TM.Count-1 do
   begin
  TempL:=TM.Strings[i];
  ProcMemo.Clear;
   extr:=0;
   d:=0;
    begin
    if (TempL<>'') and (TempL[1]<>'}') and (TempL[1]<>'{') then
      begin
      ProcL:='';
      for x:=1 to length(TempL) do
        begin
           case extr of
        0:
          begin
          if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]<>'"') then ProcL:=ProcL+TempL[x]
          else
            begin
            if (ProcL<>'') and (ProcL<>'extra') then ProcMemo.Add(ProcL)
            else if ProcL='extra' then
             begin
              Extr:=1;
              end;
            ProcL:='';
            end;
          end;
       1:
         begin

             case d of
             0:
               begin
               if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]='"') then d:=2;
               end;

             2:
               begin
               if (TempL<>'') and (TempL[x]<>'"') then Extra:=Extra+TempL[x];

               end;
             end;
         end;
        end;
      end;
     end;
    end;
  ProcessDataFromProcMemo;
  Extra:='';
  FTable.Next;
  FTable.Append;
 end;
   Ftable.Close;
   Ftable.Exclusive:=false;



end;//main


procedure TTechDatProcessor.ProcessTextFile;
begin
if (FFileName<>'') and (fileexists(FFileName)=true) then
 begin
 LoadDataFromFile;
 ProcessDataFromMemos;
 Ftable.Close;
 MessageDlg('Transfering data to database complited.',mtInformation,[mbok],0);
 end
else MessageDlg('Wrong data file name!',mtWarning,[mbOK],0);
end;

procedure TTechDatProcessor.ProcessDataBase;
begin
if (TechDatFileName<>'') then
 begin
  ProcessDataFromDatabase;
  SaveDataToFile;
  Ftable.Close;
  MessageDlg('Transfering data to external data file complited.',mtInformation,[mbok],0);
 end
else  MessageDlg('Wrong data file name',mtWarning,[mbok],0);
end;


end.
