unit UnitProcessor;
{$R *.DCR}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  db,DBTables;

type
   TUnitProcessor = class(TComponent)
  private
   Table: TTable;
   FileName: String;
   DataText: TStringList;
   ProcMemo: TStringList;
   NameMemo: TStringList;
   SNameMemo: TStringList;
   procedure EntInt(var name:string; value:integer);
   procedure EntStr(var name:string; value:string);
   procedure GetStr(var name:string);
   procedure GetInt(var name:string);
   procedure SaveDataToFile;
   procedure ProcessDataFromRecord(var t1:string);
   procedure ProcessDataFromMemos;
   procedure ProcessDataFromProcMemo;
   procedure LoadDataFromFile;
   procedure ProcessDataFromDatabase;
  protected

  public
   constructor Create(AOwner:TComponent);override;
   destructor Destroy;override;
   procedure ProcessTextFile;
   procedure ProcessDataBase;
  published
   FirstText: TStringList;
   SecondText: TStringList;
   property UnitDatFileName: string
            read FileName
            write FileName;
   property DataTableName: TTable
            read Table
            write Table
            stored false;
  end;

procedure Register;
var
  ID: integer;
  TechLvl: byte;
  AGNr,TAGr:byte;
  value:string;
implementation

procedure Register;
begin
  RegisterComponents('Game Controls', [TUnitProcessor]);
end;

constructor TUnitProcessor.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
//  Table:= TTable.create(AOwner);
  Table:=nil;
  FirstText:= TStringList.Create;
  DataText:= TStringList.Create;
  SecondText:= TStringList.Create;
  ProcMemo:= TStringList.Create;
  NameMemo:= TStringList.Create;
  SNameMemo:= TStringList.Create;
end;

destructor TUnitProcessor.Destroy;
begin
  FirstText.Destroy;
  DataText.Destroy;
  SecondText.Destroy;
  ProcMemo.Destroy;
  NameMemo.Destroy;
  SNameMemo.Destroy;
//  Table.close;
//  Table:=nil;
  Inherited Destroy;
end;

procedure TUnitProcessor.EntInt(var name:string; value:integer);
begin
Table.FieldByName(name).asInteger:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;


procedure TUnitProcessor.EntStr(var name:string; value:string);
begin
Table.FieldByName(name).asString:=value;
//MessageDlg(name+' - done',mtInformation,[mbOk],0);
//LDB.PB1.StepIt;
end;

procedure TUnitProcessor.GetStr(var name:string);
begin
value:=table.FieldByName(name).asString;
//LDB.PB1.StepIt;
end;

procedure TUnitProcessor.GetInt(var name:string);
var
V:integer;
begin
V:=table.FieldByName(name).asInteger;
value:=inttostr(V);
//LDB.PB1.StepIt;
end;

procedure TUnitProcessor.SaveDataToFile;
var
i:integer;
UnitDataFile:TextFile;
begin
FileName:= UnitDatFileName;
assignfile(UnitDataFile,FileName);
rewrite(UnitDataFile);
for i:=0 to FirstText.count-1 do
 begin
 writeln(UnitDataFile,FirstText.strings[i]);
 end;

for i:=0 to DataText.count-1 do
 begin
 writeln(UnitDataFile,DataText.strings[i]);
 end;

for i:=0 to SecondText.count-1 do
 begin
 writeln(UnitDataFile,SecondText.strings[i]);
 end;
closefile(UnitDataFile);
end;

procedure TUnitProcessor.ProcessDataFromRecord(var t1:string);
var
name:string;
i:integer;
begin

   name:='Type';
   GetInt(name);
   TAGr:=strtoint(value);
   t1:='';

   name:='LName';
   GetStr(name);
   {LDB.Label2.Caption:=value;
   LDB.Label2.Refresh;}
   t1:='"name" "'+value+'"';

   for i:=length(t1) to 31 do t1:=t1+' ';
   name:='Pext';
   GetInt(name);
   t1:=t1+'"'+value+'" "abbrev" "';

   name:='SName';
   GetStr(name);
   t1:=t1+value+'"';
   for i:=length(t1) to 60 do t1:=t1+' ';

   name:='MoveT';
   GetStr(name);
   t1:=t1+'"stats" "'+value;

   name:='Move';
   GetInt(name);
   for i:=length(t1) to 80-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Spot';
   GetInt(name);
   for i:=length(t1) to 85-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Camo';
   GetInt(name);
   for i:=length(t1) to 91-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Ag';
   GetInt(name);
   for i:=length(t1) to 97-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Armour';
   GetInt(name);
   for i:=length(t1) to 103-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='PsyDef';
   GetInt(name);
   for i:=length(t1) to 110-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='WaterA';
   GetInt(name);
   for i:=length(t1) to 116-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='WaterS';
   GetInt(name);
   for i:=length(t1) to 120-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='InDirA';
   GetInt(name);
   for i:=length(t1) to 126-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='InDirS';
   GetInt(name);
   for i:=length(t1) to 130-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='AirA';
   GetInt(name);
   for i:=length(t1) to 136-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='AirA';
   GetInt(name);
   for i:=length(t1) to 140-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='DirectA';
   GetInt(name);
   for i:=length(t1) to 146-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='DirectS';
   GetInt(name);
   for i:=length(t1) to 150-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CloseA';
   GetInt(name);
   for i:=length(t1) to 156-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CloseS';
   GetInt(name);
   for i:=length(t1) to 160-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='PsyA';
   GetInt(name);
   for i:=length(t1) to 166-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='PsyS';
   GetInt(name);
   for i:=length(t1) to 170-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='RSpeA';
   GetInt(name);
   for i:=length(t1) to 176-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='RSpeS';
   GetInt(name);
   for i:=length(t1) to 180-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='DSpeA';
   GetInt(name);
   for i:=length(t1) to 186-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='DSpeS';
   GetInt(name);
   for i:=length(t1) to 190-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CSpeA';
   GetInt(name);
   for i:=length(t1) to 196-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CSpeS';
   GetInt(name);
   for i:=length(t1) to 200-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Cargo';
   GetInt(name);
   for i:=length(t1) to 206-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CBC';
   GetInt(name);
   for i:=length(t1) to 214-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='NComb';
   GetInt(name);
   for i:=length(t1) to 223-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Crd/Tr';
   GetInt(name);
   for i:=length(t1) to 234-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Cred';
   GetInt(name);
   for i:=length(t1) to 242-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Food';
   GetInt(name);
   for i:=length(t1) to 247-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Energ';
   GetInt(name);
   for i:=length(t1) to 256-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Metal';
   GetInt(name);
   for i:=length(t1) to 262-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Trac';
   GetInt(name);
   for i:=length(t1) to 268-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Exot';
   GetInt(name);
   for i:=length(t1) to 273-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Chems';
   GetInt(name);
   for i:=length(t1) to 279-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Bio';
   GetInt(name);
   for i:=length(t1) to 283-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Elec';
   GetInt(name);
   for i:=length(t1) to 288-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='CSteel';
   GetInt(name);
   for i:=length(t1) to 295-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Wet';
   GetInt(name);
   for i:=length(t1) to 299-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Mono';
   GetInt(name);
   for i:=length(t1) to 304-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Gems';
   GetInt(name);
   for i:=length(t1) to 309-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Sing';
   GetInt(name);
   for i:=length(t1) to 314-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Unit';
   GetInt(name);
   for i:=length(t1) to 320-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Bldgs';
   GetInt(name);
   for i:=length(t1) to 326-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='T2B';
   GetInt(name);
   for i:=length(t1) to 333-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Tech1';
   GetInt(name);
   for i:=length(t1) to 341-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Tech2';
   GetInt(name);
   for i:=length(t1) to 344-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Tech3';
   GetInt(name);
   for i:=length(t1) to 347-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Tech4';
   GetInt(name);
   for i:=length(t1) to 350-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Tax';
   GetInt(name);
   for i:=length(t1) to 355-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Floc';
   GetInt(name);
   for i:=length(t1) to 361-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Range';
   GetInt(name);
   for i:=length(t1) to 368-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Eat';
   GetInt(name);
   for i:=length(t1) to 373-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Rank';
   GetInt(name);
   for i:=length(t1) to 377-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='RoP';
   GetInt(name);
   for i:=length(t1) to 382-length(value) do t1:=t1+' ';
   t1:=t1+value;

   name:='Flic';
   GetStr(name);
   t1:=t1+('"    "art" "'+value+'"');
end;

procedure TUnitProcessor.ProcessDataFromDatabase;
var
name,t1,temp:string;
AGT:integer;
begin
DataText.Clear;
table.open;
table.Refresh;
table.First;
table.edit;
name:='Type';
GetInt(name);
AGnr:=strtoint(value);
AGT:=AGnr;
{LDB.Caption:='Saving Data ...';
LDB.PB1.Position:=0;
LDB.PB2.Position:=0;
LDB.show;
LDB.Label1.Caption:='Group: '+Inttostr(AGr);
LDB.Label2.Caption:='';}
Temp:='//-------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------------';
DataText.add(temp);
Temp:='//      Name                                  Nickname               Movetype Move Spot  Camo   Ag  Armor PsyDef';
Temp:=temp+'    Water    Indirect    Air     Direct     Close      Psy     RangedSp  DirectSp  CloseSp  Cargo  CanBCargo !Combat';
Temp:=temp+'  Crd/Trn  Cred  Food     Energ Metal Trac Exot Chem Bio Elec CSteel Wet Mono Gems Sing  Unit Bldgs Turns2Bld   Reqd   Tech   Tax  Flock Range  Eat Rank RoP           Picture';
DataText.add(temp);
Temp:='//-------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------';
Temp:=temp+'---------------------------------------------------------------------------------------------------------';
DataText.add(temp);
DataText.Add('{'+inttostr(AGnr));
while not (table.Eof) do
begin
ProcessDataFromRecord(t1);
 if AGnr<>TAGr then
  begin
   AGnr:=TAgr;
  { LDB.Label1.Caption:='Group: '+Inttostr(AGnr);
   LDB.Label1.Refresh;
   LDB.PB2.StepIt;}
   DataText.Add('}');
   if AGT<AGnr-4 then
    begin
     AGT:=AGnr;
     Temp:='//-------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------------';
     DataText.add(temp);
     Temp:='//      Name                                  Nickname               Movetype Move Spot  Camo   Ag  Armor PsyDef';
     Temp:=temp+'    Water    Indirect    Air     Direct     Close      Psy     RangedSp  DirectSp  CloseSp  Cargo  CanBCargo !Combat';
     Temp:=temp+'  Crd/Trn  Cred  Food     Energ Metal Trac Exot Chem Bio Elec CSteel Wet Mono Gems Sing  Unit Bldgs Turns2Bld   Reqd   Tech   Tax  Flock Range  Eat Rank RoP           Picture';
     DataText.add(temp);
     Temp:='//-------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------';
     Temp:=temp+'---------------------------------------------------------------------------------------------------------';
     DataText.add(temp);
    end;
   DataText.Add('{'+inttostr(AGnr));
   DataText.Add(t1);
  end
 else DataText.Add(t1);
table.Next;
end;
DataText.Add('}');
table.close;
//LDB.hide;
end;

procedure TUnitProcessor.LoadDataFromFile;
var
TempL:string;
FileTextType:byte;//1-firs;2-data;3-last group;4-second
StrFile:TextFile;
begin//main
 FileTextType:=1;
 FileName:=UnitDatFileName;
 if (FileName<>'') and Fileexists(FileName) then
  begin//Filename corect
   FirstText.Clear;
   DataText.Clear;
   SecondText.Clear;
   assignfile(StrFile,FileName);
   reset(StrFile);
   while not EoF(StrFile) do
    begin//while
     readln(StrFile,TempL);
     case FileTextType of

     1:
      begin
       if (TempL<>'') and (TempL[1]='/') then FirstText.Add(TempL)
       else if (TempL<>'') and (TempL[1]='{') then
        begin
         DataText.Add(TempL);
         FileTextType:=2;
        end;
      end;

     2:
      begin
      if (TempL<>'') and (TempL[1]<>'/') and((TempL[2]+TempL[3])<>'91') then DataText.Add(tempL)
      else if (TempL<>'') and (TempL[1]='{')and ((TempL[2]+TempL[3])='91') then
       begin
        DataText.Add(TempL);
        FileTextType:=3;
       end;
      end;

     3:
      begin
      if (TempL<>'') and (TempL[1]<>'/') and (TempL[1]<>'}') then DataText.Add(TempL)
      else if (TempL<>'') and (TempL[1]='}') then
       begin
        DataText.Add(TempL);
        FileTextType:=4;
       end;
      end;

      4:
       begin
       SecondText.Add(TempL);
       end;

    end;//case of
  end;//while
   closefile(StrFile);
 end//Filename corect
 else MessageDlg('File not found!',mtWarning,[mbOK],0);
end;//main



procedure TUnitProcessor.ProcessDataFromProcMemo;
var
PM,NM,SM:TStringList;
i,value,x:integer;
FName,temp:string;
begin//main
 PM:=ProcMemo;
 NM:=NameMemo;
 SM:=SNameMemo;
 Fname:='ID';
 EntInt(FName,ID);

 Fname:='tLvl';
 EntInt(FName,TechLvl);

//MessageDlg('Gr:'+intTostr(AGnr)+' Processing... lines:'+inttostr(PM.count),mtWarning,[mbOK],0);
 Table.Edit;
 Fname:='Type';
 EntInt(FName,AGnr);

 FName:='LName';
 Temp:='';
   x:=NM.Count-2;
   for i:=0 to x do
    begin
    Temp:=temp+NM.strings[i]+' ';
    end;
//MessageDlg('LName: '+temp,mtWarning,[mbOK],0);
 EntStr(FName,temp);

 FName:='Pext';
 value:=strtoint(NM.strings[NM.count-1]);
//MessageDlg('Pext: '+inttostr(value),mtWarning,[mbOK],0);
 EntInt(FName,value);

 FName:='SName';
 Temp:='';
 if SM.Count>1 then
  begin
   x:=SM.Count-1;
   for i:=0 to x do Temp:=temp+SM.strings[i]+' ';
  end
 else Temp:=SM.strings[0];
//MessageDlg('SName: '+temp,mtWarning,[mbOK],0);
 EntStr(FName,temp);


 for i:=0 to 56 do
  begin
   FName:=Table.FieldDefs.Items[i+6].Name;
   case Table.FieldDefs.Items[i+6].DataType of

   ftString:
    begin
     temp:=PM.strings[i];
//MessageDlg('Field Name: '+Fname+' = '+temp,mtWarning,[mbOK],0);
     EntStr(FName,temp);
    end;
   ftSmallInt:
    begin
     value:=strtoint(PM.strings[i]);
//MessageDlg('Field Name: '+Fname+' = '+inttostr(value),mtWarning,[mbOK],0);
     EntInt(FName,value);
    end;
   ftInteger:
    begin
     value:=strtoint(PM.Strings[i]);
//MessageDlg('Field Name: '+Fname+' = '+inttostr(value),mtWarning,[mbOK],0);
     EntInt(FName,value);
    end;
   end;
  end;
 table.Post;
//MessageDlg('complited',mtWarning,[mbOK],0);
end;//main



procedure TUnitProcessor.ProcessDataFromMemos;
var
TM:TStringList;
TempL,ProcL:string;
i,x:integer;
Process:byte; //1-LName & abbrev; 2-SName ;3-stats
begin//main
TM:=DataText;
   table.Close;
   table.Exclusive:=true;
   table.open;
   table.edit;
   table.EmptyTable;
   table.First;
   table.Insert;
//MessageDlg('Ex = on',mtWarning,[mbOK],0);
ID:=0;
TechLvl:=0;
AGnr:=0;
for i:=0 to DataText.Count-1 do
 begin//TM loop
  TempL:=TM.strings[i];
  if (TempL<>'') and (TempL[1]='{') then
   begin
    if (TempL[3]<>'') and (TempL[3]<>' ') then AGnr:=strtoint(TempL[2]+TempL[3])
    else AGnr:=strtoint(TempL[2]);
    TechLvl:=0;
   end
  else if (TempL<>'') and (TempL<>'}') then
  begin
  ProcMemo.Clear;
  NameMemo.Clear;
  SNameMemo.clear;
  //Extracting Long Name and abbrev
  if (TempL<>'') and (TempL[1]<>'}') and (TempL[1]<>'{') then
   begin//Line loop
    ProcL:='';
    Process:=1;
     for x:=1 to length(TempL) do
      begin
      case Process of

      1:
       begin
        if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]<>'"') then ProcL:=ProcL+TempL[x]
        else
         begin
          if (ProcL<>'') and (ProcL<>'abbrev')  and (ProcL<>'name') then NameMemo.Add(ProcL)
          else if ProcL='abbrev' then Process:=2;
          ProcL:='';
         end;
       end;

      2:
       begin

        if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]<>'"') then ProcL:=ProcL+TempL[x]
        else
         begin
          if (ProcL<>'') and (ProcL<>'stats') then SNameMemo.Add(ProcL)
          else if ProcL='stats' then Process:=3;
          ProcL:='';
         end;
       end;

      3:
       begin
        if (TempL<>'') and (TempL[x]<>' ') and (TempL[x]<>'"') then ProcL:=ProcL+TempL[x]
        else
         begin
          if (ProcL<>'') and (ProcL<>'art') then ProcMemo.Add(ProcL);
          ProcL:='';
         end;
       end;
      end;//case of
    end;
   end;//Line loop
//MessageDlg('Processing Data',mtWarning,[mbOK],0);
  if ProcMemo.Count>0 then ProcessDataFromProcMemo;
  Inc(ID);
  Inc(TechLvl);
  Table.Next;
  Table.Append;
 end;//TM loop
//MessageDlg('Ex = off',mtWarning,[mbOK],0);
 end;
   table.Close;
   table.Exclusive:=false;
end;//Main

procedure TUnitProcessor.ProcessTextFile;
begin
if (UnitDatFileName<>'') and (fileexists(UnitDatFileName)) then
 begin
  LoadDataFromFile;
  ProcessDataFromMemos;
   table.Close;
  MessageDlg('Transfering data to database complited.',mtInformation,[mbok],0);
 end
else  MessageDlg('Wrong data file name',mtWarning,[mbok],0);
end;

procedure TUnitProcessor.ProcessDataBase;
begin
if (UnitDatFileName<>'') then
 begin
  ProcessDataFromDatabase;
//  messageDlg('database - done',mtinformation,[mbok],0);
  SaveDataToFile;
  table.Close;
  MessageDlg('Transfering data to external data file complited.',mtInformation,[mbok],0);
 end
else  MessageDlg('Wrong data file name',mtWarning,[mbok],0);
end;

end.
